# -*- coding: utf-8 -*-

class ObjectToolsMixin:
    def __init__(self, *args, **kwargs):
        self.change_list_template = 'admin/custom_change_list.html'
        self.default_change_list_template = 'admin/change_list.html'
        super().__init__(*args, **kwargs)

    def get_object_tools(self, request):
        """
        [{'admin_urlname': '', 'title': ''}]
        :param request:
        :return: list of object tools
        """
        return []

    def changelist_view(self, request, extra_context=None):
        extra_context = self.get_object_tools_extra_context(request, extra_context)
        return super().changelist_view(request, extra_context)

    def get_object_tools_extra_context(self, request, extra_context=None):
        extra_context = extra_context or {}
        extra_context['object_tools'] = self.get_object_tools(request)
        extra_context['super_change_list_template'] = super().change_list_template or self.default_change_list_template
        return extra_context
